package org.mandarax.xkb.framework;

/**
 *  Copyright (C) 1999-2004  Jens Dietrich (mailto:mandarax@jbdietrich.com)
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import org.jdom.Element;
import org.mandarax.kernel.Fact;
import org.mandarax.kernel.LogicFactory;
import org.mandarax.kernel.Rule;
import org.mandarax.xkb.XKBException;
/**
 * An adapter class for rules.
 * @see org.mandarax.kernel.Rule
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 1.6 
 */

public class XMLAdapter4Rules extends AbstractXMLAdapter {
      public static final String RULE = "imp";
      public static final String BODY = "_body";
      public static final String HEAD = "_head";
      public static final String OR = "or";
      public static final String AND = "and";
      public static final String CONNECTIVE = "connective";

/**
 * Export an object, i.e., convert it to an element in the DOM.
 * @param obj an object
 * @param driver the generic driver
 * @param cache a cache used in order to associate the same
 * id with various occurences of the same object
 * @exception an XKBException is thrown if export fails
 */
public Element exportObject(Object obj,GenericDriver driver,Map cache) throws  XKBException {
      check(obj,Rule.class);
      Rule rule = (Rule)obj;
      Element e = new Element(RULE);
      Element eConn = new Element(rule.isBodyOrConnected()?OR:AND);
      Element eBody = new Element(BODY);
      eBody.addContent(eConn);
      e.addContent(eBody);
      for (Iterator it = rule.getBody().iterator();it.hasNext();) {
            Element el = exportObject(it.next(),GenericDriver.FACT,driver,cache);
            eConn.addContent(el);
      }
      Element eHead = new Element(HEAD);
      e.addContent(eHead);
      Element el = exportObject(rule.getHead(),GenericDriver.FACT,driver,cache);
      eHead.addContent(el);
      return e;
}
/**
 * Build an object from an XML element.
 * @param e an element
 * @param driver the generic driver
 * @param cache a cache used to identify objects that have the same id
 * @param lfactory the logic factory used to create objects
 * @exception an XKBException is thrown if import fails
 */
public Object importObject(Element e,GenericDriver driver,Map cache,LogicFactory lfactory) throws XKBException {
      // get  body
      Element eBody = e.getChild(BODY);
      Element eConn = (Element)eBody.getChildren().get(0);
      boolean isOrConnected = OR.equals(eConn.getName());
      List body = new Vector();
      XMLAdapter adapter4Facts = null;
      List children = eConn.getChildren();
      for (Iterator it = children.iterator();it.hasNext();) {
              Element eFact = (Element)it.next();
              if (adapter4Facts==null) adapter4Facts = driver.getAdapterByTagName(eFact.getName());
              Fact premisse = (Fact)adapter4Facts.importObject(eFact,driver,cache,lfactory);
              body.add(premisse);

      }
      // get head
      Element eHead = e.getChild(HEAD);
      Fact head = (Fact)importChild(eHead,GenericDriver.FACT,driver,cache,lfactory);

      // build rule
      return lfactory.createRule(body,head,isOrConnected);
}
/**
 * Get the name of the associated tag (element).
 * @return a string
 */
public String getTagName() {
      return RULE;
}
/**
 * Get the kind of object the adapter can export/import.
 * @return a string
 */
public String getKindOfObject() {
      return GenericDriver.RULE;
}
}
